#!/usr/bin/env python3
#

import os
import requests
import subprocess
import sys
import time

computerId = subprocess.check_output(['./premiumaddon', '--print-computer-id']).decode().strip()

licenseId = input('License Id:')
email = input('Email:')

r = requests.get('https://licdb-333117.ew.r.appspot.com/register-user',
                 params={'t': str(int(time.time())),
                         'computerId': computerId,
                         'licenseId': licenseId,
                         'email': email,
                         'os': sys.platform})

if not r.text.startswith('OK1'):
    print(r.text)
    sys.exit(1)

if input('Receive emails about releases? [y/N] ') in ('y','Y'):
    subscribe = '1'
else:
    subscribe = '0'

print('You should have received an email from noreply@cppchecksolutions.com with a 4-digit code.')
code = input('Enter code:')
r = requests.get('https://licdb-333117.ew.r.appspot.com/get-key',
                 params={'computerId': computerId,
                         'licenseId': licenseId,
                         'email': email,
                         'subscribe': subscribe,
                         'code': code,
                         'os': sys.platform})

if not r.text.startswith('OK2'):
    print(r.text)
    sys.exit(1)

license = r.text[r.text.find('\n')+1:]

with open(os.path.expanduser('~/' + computerId + '.lic'), 'wt') as f:
    f.write(license)

print('')
print('Registration succeeded. License file ~/' + computerId + '.lic has been created.')
print('Please copy the license file either to folder /etc/cppcheckpremium/ or folder ~/.cppcheckpremium/')

